//
// $Id: DatabaseException.java 430 2009-04-29 16:17:39Z par.winzell $
//
// Depot library - a Java relational persistence library
// Copyright (C) 2006-2008 Michael Bayne and Pär Winzell
//
// This library is free software; you can redistribute it and/or modify it
// under the terms of the GNU Lesser General Public License as published
// by the Free Software Foundation; either version 2.1 of the License, or
// (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

package com.samskivert.depot;

/**
 * Represents a failure reported by the underlying database.
 */
public class DatabaseException extends RuntimeException
{
    /**
     * Constructs a database exception with the specified error message.
     */
    public DatabaseException (String message)
    {
        super(message);
    }

    /**
     * Constructs a database exception with the specified error message and the chained causing
     * event.
     */
    public DatabaseException (String message, Throwable cause)
    {
        super(message);
        initCause(cause);
    }

    /**
     * Constructs a database exception with the specified chained causing event.
     */
    public DatabaseException (Throwable cause)
    {
        initCause(cause);
    }
}
